local frmRFL_LootTracker = nil;
local rfl_LT_RefreshTime = 0;
local RFL_LT_lootItemHyperlinks = {};
local L;

function RollForLoot:BuildLootTrackerFrame()
	if (L == nil) then
		L = LibStub("AceLocale-3.0"):GetLocale("RollForLoot", true);
	end
	
	if(frmRFL_LootTracker == nil) then
		frmRFL_LootTracker = CreateFrame("Frame", "frmRFL_LootTracker", UIParent, "BasicFrameTemplate");

		-- Build Loot Tracker Frame
		frmRFL_LootTracker:SetWidth(375);
		frmRFL_LootTracker:SetHeight(512);
		frmRFL_LootTracker:SetFrameStrata("DIALOG");
		frmRFL_LootTracker:SetPoint("CENTER",0,0)
		frmRFL_LootTracker:SetMovable(true)
		frmRFL_LootTracker:EnableMouse(true)
		frmRFL_LootTracker:RegisterForDrag("LeftButton")
		frmRFL_LootTracker:SetScript("OnDragStart", frmRFL_LootTracker.StartMoving)
		frmRFL_LootTracker:SetScript("OnDragStop", frmRFL_LootTracker.StopMovingOrSizing)
		frmRFL_LootTracker:SetScript("OnUpdate", function(self, elapsed) RollForLoot:RefreshLootTracker(self,elapsed) end)
		
		-- Build Loot Tracker Title
		local frmRFL_LTTitleText = frmRFL_LootTracker:CreateFontString("$parentTitle", "Overlay", "GameFontNormal")
		frmRFL_LTTitleText:SetText("Roll For Loot: Assigned Loot Tracker")
		frmRFL_LTTitleText:SetPoint("TOP", frmRFL_LootTracker, 0, -6)
		
		-- Build seperator frame
		local frmRFL_LTSeperatorTexture = frmRFL_LootTracker:CreateTexture("textureRFLLootSeperator", "ARTWORK" , nil, nil )
		textureRFLLootSeperator:SetTexture("Interface\\AddOns\\RollForLoot\\Media\\rfl_seperator") 
		textureRFLLootSeperator:SetSize(frmRFL_LootTracker:GetWidth(), 32)
		textureRFLLootSeperator:SetPoint("CENTER", frmRFL_LootTracker, "CENTER", -1, 0)		
		-- Build Raid Player Background
		
		-- Build Loot Tracker Player Scroll Frame
		local frmRFL_LT_PlayerScroll = CreateFrame("ScrollFrame", "frmRFL_LT_PlayerScroll", frmRFL_LootTracker, "UIPanelScrollFrameTemplate")
		frmRFL_LT_PlayerScroll:SetWidth(frmRFL_LootTracker:GetWidth() - 35);
		frmRFL_LT_PlayerScroll:SetHeight(frmRFL_LootTracker:GetHeight() / 2 - 30);
		frmRFL_LT_PlayerScroll:SetPoint("TOPLEFT", frmRFL_LootTracker, "TOPLEFT", 5, -25);

		-- Build Loot Tracker Player Background Frame
		local frmRFL_LootTrackerPlayerBackground = CreateFrame("Frame", "frmRFL_LootTrackerPlayerBackground", nil, nil );
		frmRFL_LootTrackerPlayerBackground:SetPoint("TOPLEFT", 8, -75);
		frmRFL_LootTrackerPlayerBackground:SetHeight(frmRFL_LT_PlayerScroll:GetHeight());
		frmRFL_LootTrackerPlayerBackground:SetWidth(frmRFL_LT_PlayerScroll:GetWidth());
		frmRFL_LootTrackerPlayerBackground:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
			edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
			tile = true, tileSize = 16, edgeSize = 16,
			insets = {left = 1, right = 1, top = 1, bottom = 1}}
		);
		
		frmRFL_LT_PlayerScroll:SetScrollChild(frmRFL_LootTrackerPlayerBackground);	
		
		-- Build Loot Tracker Player Header Font Strings
		
		-- Loot Roll Header Font Strings
		fsRFL_LT_PlayerName = frmRFL_LootTrackerPlayerBackground:CreateFontString("fsRFL_LT_PlayerName", "ARTWORK" , "GameFontNormalSmall")
		fsRFL_LT_PlayerName:SetPoint("TOPLEFT", frmRFL_LootTrackerPlayerBackground, "TOPLEFT", 10, -5)
		fsRFL_LT_PlayerName:SetSize(145, 15)
		fsRFL_LT_PlayerName:SetJustifyH("LEFT")
		fsRFL_LT_PlayerName:SetText("Player Name")
		
		fsRFL_LT_MainSpecCount = frmRFL_LootTrackerPlayerBackground:CreateFontString("fsRFL_LT_MainSpecCount", "ARTWORK" , "GameFontNormalSmall")
		fsRFL_LT_MainSpecCount:SetPoint("LEFT", fsRFL_LT_PlayerName, "RIGHT", 0, 0)
		fsRFL_LT_MainSpecCount:SetSize(50, 15)
		fsRFL_LT_MainSpecCount:SetJustifyH("CENTER")
		fsRFL_LT_MainSpecCount:SetText("Main")
		
		fsRFL_LT_OffSpecCount = frmRFL_LootTrackerPlayerBackground:CreateFontString("fsRFL_LT_OffSpecCount", "ARTWORK" , "GameFontNormalSmall")
		fsRFL_LT_OffSpecCount:SetPoint("LEFT", fsRFL_LT_MainSpecCount, "RIGHT", 0, 0)
		fsRFL_LT_OffSpecCount:SetSize(50, 15)
		fsRFL_LT_OffSpecCount:SetJustifyH("CENTER")
		fsRFL_LT_OffSpecCount:SetText("Off")
		
		fsRFL_LT_NASpecCount = frmRFL_LootTrackerPlayerBackground:CreateFontString("fsRFL_LT_NASpecCount", "ARTWORK" , "GameFontNormalSmall")
		fsRFL_LT_NASpecCount:SetPoint("LEFT", fsRFL_LT_OffSpecCount, "RIGHT", 0, 0)
		fsRFL_LT_NASpecCount:SetSize(75, 15)
		fsRFL_LT_NASpecCount:SetJustifyH("CENTER")
		fsRFL_LT_NASpecCount:SetText("Greed / Pass")
		
		-- Build Assigned Loot Background
		
	    -- Build Assigned Loot Scroll Frame
		local frmRFL_LT_AssignedLootScroll = CreateFrame("ScrollFrame", "frmRFL_LT_AssignedLootScroll", frmRFL_LootTracker, "UIPanelScrollFrameTemplate")
		frmRFL_LT_AssignedLootScroll:SetWidth(frmRFL_LootTracker:GetWidth() - 35);
		frmRFL_LT_AssignedLootScroll:SetHeight(frmRFL_LootTracker:GetHeight() / 2 - 20);
		frmRFL_LT_AssignedLootScroll:SetPoint("TOPLEFT", frmRFL_LootTracker, "TOPLEFT", 5, -265);

		-- Build Loot Tracker Player Background Frame
		local frmRFL_LT_AssignedLootBackground = CreateFrame("Frame", "frmRFL_LT_AssignedLootBackground", nil, nil );
		frmRFL_LT_AssignedLootBackground:SetPoint("TOPLEFT", 8, -75);
		frmRFL_LT_AssignedLootBackground:SetHeight(frmRFL_LT_AssignedLootScroll:GetHeight());
		frmRFL_LT_AssignedLootBackground:SetWidth(frmRFL_LT_AssignedLootScroll:GetWidth());
		frmRFL_LT_AssignedLootBackground:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
			edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
			tile = true, tileSize = 16, edgeSize = 16,
			insets = {left = 1, right = 1, top = 1, bottom = 1}}
		);
		
		frmRFL_LT_AssignedLootScroll:SetScrollChild(frmRFL_LT_AssignedLootBackground);	
	end

	frmRFL_LootTracker:Hide();
end

function RollForLoot:AddPlayerToLTFrame(i, playerName, mainSpecCount, offSpecCount, NASpecCount)
	local frmRFL_LT_Player_i = _G["frmRFL_LT_Player" .. i];
	local fsRFL_LT_PlayerName_i;
	local fsRFL_LT_mainSpecCount_i;
	local fsRFL_LT_offSpecCount_i;
	local fsRFL_LT_NASpecCount_i;
		
	if frmRFL_LT_Player_i == nil then
		
		-- RollForLoot:Print("Build New Player Frame")
	
		frmRFL_LT_Player_i = CreateFrame("Frame", "frmRFL_LT_Player" .. i, frmRFL_LootTrackerPlayerBackground, nil);
		frmRFL_LT_Player_i:SetPoint("TOPLEFT", 10, -20*(i-1)-20);
		frmRFL_LT_Player_i:SetHeight(20);
		frmRFL_LT_Player_i:SetWidth(frmRFL_LT_PlayerScroll:GetWidth());
		frmRFL_LT_Player_i:EnableMouse(true);
		frmRFL_LT_Player_i:SetScript("OnMouseDown", function(self,button) RollForLoot:DisplayAssignedLoot(self) end);
				
		fsRFL_LT_PlayerName_i = frmRFL_LT_Player_i:CreateFontString("fsRFL_LT_PlayerName_" .. i, "ARTWORK" , "GameFontWhiteSmall")
		fsRFL_LT_PlayerName_i:SetPoint("LEFT", frmRFL_LT_Player_i, "LEFT", 0, 0)
		fsRFL_LT_PlayerName_i:SetSize(145, 15)
		fsRFL_LT_PlayerName_i:SetJustifyH("LEFT")
		
		fsRFL_LT_PlayerMainSpecCount_i = frmRFL_LT_Player_i:CreateFontString("fsRFL_LT_PlayerMainSpecCount_" .. i, "ARTWORK" , "GameFontWhiteSmall")
		fsRFL_LT_PlayerMainSpecCount_i:SetPoint("LEFT", fsRFL_LT_PlayerName_i, "RIGHT", 0, 0)
		fsRFL_LT_PlayerMainSpecCount_i:SetSize(50, 15)
		fsRFL_LT_PlayerMainSpecCount_i:SetJustifyH("CENTER")
		fsRFL_LT_PlayerMainSpecCount_i:SetText("N/A")
		
		fsRFL_LT_PlayerOffSpecCount_i = frmRFL_LT_Player_i:CreateFontString("fsRFL_LT_PlayerOffSpecCount_" .. i, "ARTWORK" , "GameFontWhiteSmall")
		fsRFL_LT_PlayerOffSpecCount_i:SetPoint("LEFT", fsRFL_LT_PlayerMainSpecCount_i, "RIGHT", 0, 0)
		fsRFL_LT_PlayerOffSpecCount_i:SetSize(50, 15)
		fsRFL_LT_PlayerOffSpecCount_i:SetJustifyH("CENTER")
		fsRFL_LT_PlayerOffSpecCount_i:SetText("N/A")
		
		fsRFL_LT_PlayerNASpecCount_i = frmRFL_LT_Player_i:CreateFontString("fsRFL_LT_PlayerNASpecCount_" .. i, "ARTWORK" , "GameFontWhiteSmall")
		fsRFL_LT_PlayerNASpecCount_i:SetPoint("LEFT", fsRFL_LT_PlayerOffSpecCount_i, "RIGHT", 0, 0)
		fsRFL_LT_PlayerNASpecCount_i:SetSize(75, 15)
		fsRFL_LT_PlayerNASpecCount_i:SetJustifyH("CENTER")
		fsRFL_LT_PlayerNASpecCount_i:SetText("N/A")
	else
		fsRFL_LT_PlayerName_i = _G["fsRFL_LT_PlayerName_" .. i];
		fsRFL_LT_PlayerMainSpecCount_i = _G["fsRFL_LT_PlayerMainSpecCount_" .. i];
		fsRFL_LT_PlayerOffSpecCount_i = _G["fsRFL_LT_PlayerOffSpecCount_" .. i];
		fsRFL_LT_PlayerNASpecCount_i = _G["fsRFL_LT_PlayerNASpecCount_" .. i];
	end
		
	fsRFL_LT_PlayerName_i:SetText(playerName);
	
	if RollForLoot:getRaidIndex(playerName) ~= 0 then
		local color = RAID_CLASS_COLORS[RFLRaidRoster[RollForLoot:getRaidIndex(playerName)]["fileName"]];
		fsRFL_LT_PlayerName_i:SetTextColor(color.r, color.g, color.b, 1);
	else
		fsRFL_LT_PlayerName_i:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b, 1); -- Set color to gray if the player is not longer in the raid roster.
	end
	
	if (frmRFL_LT_Player_i:GetHeight() * (i+1)) > frmRFL_LT_PlayerScroll:GetHeight() then
		frmRFL_LootTrackerPlayerBackground:SetHeight(frmRFL_LT_Player_i:GetHeight() * (i+1) + 10);  -- Add some extra spacing at the end for appearances
	else
		frmRFL_LootTrackerPlayerBackground:SetHeight(frmRFL_LT_PlayerScroll:GetHeight());
	end

	fsRFL_LT_PlayerMainSpecCount_i:SetText(mainSpecCount);
	fsRFL_LT_PlayerOffSpecCount_i:SetText(offSpecCount);
	fsRFL_LT_PlayerNASpecCount_i:SetText(NASpecCount);
	frmRFL_LT_Player_i:Show();
end


function RollForLoot:DisplayLootTracker()
	if next(RFL_AwardedLoot) == nil then
		RollForLoot:Print("No loot has been assigned yet!")
		return;
	end
	
	if frmRFL_LootTracker == nil then
		RollForLoot:BuildLootTrackerFrame();
		-- RollForLoot:Print("Initial Setup Loot Tracker Frame")
	end
	
	local i = 0;
	for playerName, _ in pairs(RFL_AwardedLoot) do
		i = i + 1;
		
		local mainSpecCount = 0;
		local offSpecCount = 0;
		local NASpecCount = 0;
		
		for j, k in pairs(RFL_AwardedLoot[playerName]) do
			
			if type(k) == "table" then
				if k["RollSpec"] == L['RFL_MAINSPEC']		then mainSpecCount = mainSpecCount + 1
				elseif k["RollSpec"] == L['RFL_OFFSPEC']	then offSpecCount = offSpecCount + 1
				elseif k["RollSpec"] == L['RFL_NASPEC'] 	then NASpecCount = NASpecCount + 1
				else								 			 RollForLoot:Print("Invalid RollSpec Found: " .. tostring(k["RollSpec"]));
				end
			end
		end
		
		
		RollForLoot:AddPlayerToLTFrame(i, playerName, mainSpecCount,offSpecCount,NASpecCount);
	end	
	
	frmRFL_LootTracker:Show();
	frmRFL_LootTracker:SetClampedToScreen(true);
end

function RollForLoot:RefreshLootTracker(self,elapsed)
    rfl_LT_RefreshTime = rfl_LT_RefreshTime + elapsed;
    if rfl_LT_RefreshTime >= 10 then
        if frmRFL_LootTracker:IsShown() then
			RollForLoot:DisplayLootTracker()
		end
		rfl_LT_RefreshTime = 0
    end
end

local previousPlayerFrame = nil;

function RollForLoot:DisplayAssignedLoot(self)
	-- RollForLoot:Print("Display Assigned Loot Click Registered")

	local backdrop = {
	  bgFile = "Interface\\PaperDollInfoFrame\\UI-Character-Tab-Highlight", -- path to the background texture
	  edgeFile = nil, 	-- path to the border texture
	  tile = false, 	-- true to repeat the background texture to fill the frame, false to scale it
	  tileSize = 32, 	-- size (width or height) of the square repeating background tiles (in pixels)
	  edgeSize = 32, 	-- thickness of edge segments and square size of edge corners (in pixels)
	  insets = {		-- distance from the edges of the frame to those of the background texture (in pixels)
		left = 0,
		right = 15,
		top = 0,
		bottom = 0
	  }
	}
	
	if previousPlayerFrame ~= nil then
		previousPlayerFrame:SetBackdrop(nil)
		RollForLoot:RFL_LT_ClearLootFrames();
	end
	
	local idStart, idStop = string.find(self:GetName(), "%d+");
	self:SetBackdrop(backdrop);
	self:SetBackdropColor(1,1,1,0.5);
	
    local playerName = _G["fsRFL_LT_PlayerName_" .. string.sub(self:GetName(),idStart, idStop)]:GetText();
	
	for j, AssignedlootItem in pairs(RFL_AwardedLoot[playerName]) do
		if type(AssignedlootItem) == "table" then
			RollForLoot:AddAssignedLootToLTFrame(j, AssignedlootItem["LootID"], AssignedlootItem["RollSpec"])
		end
	end
	
	if (RFL_AwardedLoot[playerName].LootCount % 2 ~= 0) then
		frmRFL_LT_AssignedLootBackground:SetHeight(50*(((RFL_AwardedLoot[playerName].LootCount+1)/2)-1)+58);
	else
		frmRFL_LT_AssignedLootBackground:SetHeight(50*((RFL_AwardedLoot[playerName].LootCount/2)-1)+58);
	end
	previousPlayerFrame = self;
end

function RollForLoot:AddAssignedLootToLTFrame(i, lootID, rollSpec)
	lootItem = RFL_LootRollHistory[lootID]
	
	if (lootItem ~= nil) then
		RollForLoot:AddAssignedLootItemFrame(i, lootItem["Texture"], lootItem["Item"], lootItem["Hyperlink"], lootItem["Quality"], rollSpec, lootID)
	end
end

function RollForLoot:AddAssignedLootItemFrame(i, texture, item, lootlink, quality, rollSpec, uniqueID)
	local iLootFrameHeight = 50;
	local frmAssigndLootBkgd = _G["frmRFL_LT_AssignedLootBackground"]
	
	if (frmAssigndLootBkgd ~= nil) then
	
		--local frm_LT_AssignedLootItemFrame_i = _G["frm_LT_AssignedLootItemFrame_" .. i]
		local frmRFL_LT_LootIcon_i = _G["frmRFL_LT_LootIcon_" .. i]

		if (frmRFL_LT_LootIcon_i == nil) then
			
			frmRFL_LT_LootIcon_i = CreateFrame("Button", "frmRFL_LT_LootIcon_" .. i, frmAssigndLootBkgd, "ItemButtonTemplate")
			
			if ((i % 2) ~= 0) then
				local width = (iLootFrameHeight*(((i+1)/2)-1)*-1)-10;
				frmRFL_LT_LootIcon_i:SetPoint("TOPLEFT", 10, width)
			else
				local width = (iLootFrameHeight*(((i)/2)-1)*-1)-10;
				frmRFL_LT_LootIcon_i:SetPoint("TOPLEFT", 175, width)
			end
			
			textureRFL_LT_LootIconName_i = frmRFL_LT_LootIcon_i:CreateTexture("textureRFLLootIconName" .. i, "ARTWORK" , nil, nil )
			textureRFL_LT_LootIconName_i:SetTexture("Interface\\QUESTFRAME\\UI-QuestItemNameFrame") 
			textureRFL_LT_LootIconName_i:SetSize(130, 62)
			textureRFL_LT_LootIconName_i:SetPoint("LEFT", 30, 0)
			fsRFL_LT_LootIconName_i = frmRFL_LT_LootIcon_i:CreateFontString("fsRFL_LT_LootIconName_" .. i, "ARTWORK" , "GameFontNormal")
			fsRFL_LT_LootIconName_i:SetPoint("LEFT", frmRFL_LT_LootIcon_i, "RIGHT", 8, 0)
			fsRFL_LT_LootIconName_i:SetSize(93, 38)
			fsRFL_LT_LootIconName_i:SetJustifyH("LEFT")
		
			-- Add UniqueId Hidden FontString to support button clicks
			fs_LT_UIDLabel_i = frmRFL_LT_LootIcon_i:CreateFontString("fs_LT_UIDLabel_" .. i, "ARTWORK", "GameFontNormalLarge")
			fs_LT_UIDLabel_i:SetPoint("TOPRIGHT", frmRFL_LT_LootIcon_i, "TOPRIGHT" , 0, 0);
			fs_LT_UIDLabel_i:SetText("UNIQUEID");
		else
			fsRFL_LT_LootIconName_i = _G["fsRFL_LT_LootIconName_" .. i]
			fs_LT_UIDLabel_i = _G["fs_LT_UIDLabel_" .. i]		
		end
		
		frmRFL_LT_LootIcon_i.icon:SetTexture(texture);

		-- Set font color of the item name to match the quality
		local redComponent, greenComponent, blueComponent = GetItemQualityColor(quality)
		fsRFL_LT_LootIconName_i:SetText(item);
		fsRFL_LT_LootIconName_i:SetTextColor(redComponent, greenComponent, blueComponent, 1)
		
		-- Set Unique ID
		fs_LT_UIDLabel_i:SetText(uniqueID);
		fs_LT_UIDLabel_i:SetAlpha(0.0);

		-- Store Hyperlink to loot for the tooltip to use
		RFL_LT_lootItemHyperlinks[frmRFL_LT_LootIcon_i:GetName() .. "Link"] = lootlink
		frmRFL_LT_LootIcon_i:SetScript("OnEnter", function(self) RollForLoot:LT_MouseOverTooltip(self) end)
		frmRFL_LT_LootIcon_i:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
		frmRFL_LT_LootIcon_i:RegisterForClicks("RightButtonDown")
		--frmRFL_LT_LootIcon_i:SetScript("OnClick", function(self) if IsControlKeyDown() then RollForLoot:TransmogDisplayItemLink(self) end end)
	
		frmRFL_LT_LootIcon_i:Show()
	end
end

function RollForLoot:LT_MouseOverTooltip(self)
    GameTooltip:SetOwner(self, "ANCHOR_LEFT");
	GameTooltip:SetHyperlink(RFL_LT_lootItemHyperlinks[self:GetName() .. "Link"])
end

function RollForLoot:RFL_LT_ClearLootFrames()
	--RollForLoot:Print("Begin ClearLootFrames")
	if (frmRFL_LT_AssignedLootBackground ~= nil) then
		local kids = { frmRFL_LT_AssignedLootBackground:GetChildren() };

		for _, child in ipairs(kids) do
			if (child ~= nil) then
				child:Hide()
			end
		end
	end
end

function RollForLoot:RFL_LT_ClearLootPlayerFrames()
	if (frmRFL_LootTrackerPlayerBackground ~= nil) then
		local kids = { frmRFL_LootTrackerPlayerBackground:GetChildren() };

		for _, child in ipairs(kids) do
			if (child ~= nil) then
				if (string.find(child:GetName(), "frmRFL_LT_Player") ~= nil) then
					child:Hide()
				end
			end
		end
		
		RollForLoot:RFL_LT_ClearLootFrames();
	end
end


